/*
Copyright 2020 The Kubernetes Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package v1alpha1

import (
	context "context"

	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	gentype "k8s.io/client-go/gentype"
	apisv1alpha1 "sigs.k8s.io/mcs-api/pkg/apis/v1alpha1"
	scheme "sigs.k8s.io/mcs-api/pkg/client/clientset/versioned/scheme"
)

// ServiceExportsGetter has a method to return a ServiceExportInterface.
// A group's client should implement this interface.
type ServiceExportsGetter interface {
	ServiceExports(namespace string) ServiceExportInterface
}

// ServiceExportInterface has methods to work with ServiceExport resources.
type ServiceExportInterface interface {
	Create(ctx context.Context, serviceExport *apisv1alpha1.ServiceExport, opts v1.CreateOptions) (*apisv1alpha1.ServiceExport, error)
	Update(ctx context.Context, serviceExport *apisv1alpha1.ServiceExport, opts v1.UpdateOptions) (*apisv1alpha1.ServiceExport, error)
	// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
	UpdateStatus(ctx context.Context, serviceExport *apisv1alpha1.ServiceExport, opts v1.UpdateOptions) (*apisv1alpha1.ServiceExport, error)
	Delete(ctx context.Context, name string, opts v1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error
	Get(ctx context.Context, name string, opts v1.GetOptions) (*apisv1alpha1.ServiceExport, error)
	List(ctx context.Context, opts v1.ListOptions) (*apisv1alpha1.ServiceExportList, error)
	Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *apisv1alpha1.ServiceExport, err error)
	ServiceExportExpansion
}

// serviceExports implements ServiceExportInterface
type serviceExports struct {
	*gentype.ClientWithList[*apisv1alpha1.ServiceExport, *apisv1alpha1.ServiceExportList]
}

// newServiceExports returns a ServiceExports
func newServiceExports(c *MulticlusterV1alpha1Client, namespace string) *serviceExports {
	return &serviceExports{
		gentype.NewClientWithList[*apisv1alpha1.ServiceExport, *apisv1alpha1.ServiceExportList](
			"serviceexports",
			c.RESTClient(),
			scheme.ParameterCodec,
			namespace,
			func() *apisv1alpha1.ServiceExport { return &apisv1alpha1.ServiceExport{} },
			func() *apisv1alpha1.ServiceExportList { return &apisv1alpha1.ServiceExportList{} },
		),
	}
}
